Switch include to test
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archives".
202     #   The name is chosen to match what ci-management expects.
203     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
204     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
205     # Directories created if not present:
206     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
207     # Functions called:
208     # - die - Print to stderr and exit.
209
210     set -exuo pipefail
211
212     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
213         die "Some error during locating of this source file."
214     }
215     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
216         die "Some error during dirname call."
217     }
218     # Current working directory could be in a different repo, e.g. VPP.
219     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
220     relative_csit_dir=$(git rev-parse --show-toplevel) || {
221         die "Git rev-parse failed."
222     }
223     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
224     popd || die "Popd failed."
225     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
226         die "Readlink failed."
227     }
228     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
229         die "Readlink failed."
230     }
231     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
232         die "Readlink failed."
233     }
234     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
235         die "Readlink failed."
236     }
237     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
238         die "Readlink failed."
239     }
240     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
241         die "Readlink failed."
242     }
243
244     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archives") || {
245         die "Readlink failed."
246     }
247     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
248     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
249         die "Readlink failed."
250     }
251     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
252     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
253         die "Readlink failed."
254     }
255     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
256 }
257
258
259 function compose_pybot_arguments () {
260
261     # Variables read:
262     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
263     # - DUT - CSIT test/ subdirectory, set while processing tags.
264     # - TAGS - Array variable holding selected tag boolean expressions.
265     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
266     # - TEST_CODE - The test selection string from environment or argument.
267     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
268     # Variables set:
269     # - PYBOT_ARGS - String holding part of all arguments for pybot.
270     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
271
272     set -exuo pipefail
273
274     # No explicit check needed with "set -u".
275     PYBOT_ARGS=("--loglevel" "TRACE")
276     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
277
278     case "${TEST_CODE}" in
279         *"device"*)
280             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
281             ;;
282         *"perf"*)
283             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
284             ;;
285         *)
286             die "Unknown specification: ${TEST_CODE}"
287     esac
288
289     EXPANDED_TAGS=()
290     for tag in "${TAGS[@]}"; do
291         if [[ ${tag} == "!"* ]]; then
292             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
293         else
294             EXPANDED_TAGS+=("${SELECTION_MODE}" "${tag}")
295         fi
296     done
297
298     EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}")
299 }
300
301
302 function deactivate_docker_topology () {
303
304     # Deactivate virtual vpp-device topology by removing containers.
305     #
306     # Variables read:
307     # - NODENESS - Node multiplicity of desired testbed.
308     # - FLAVOR - Node flavor string, usually describing the processor.
309
310     set -exuo pipefail
311
312     case_text="${NODENESS}_${FLAVOR}"
313     case "${case_text}" in
314         "1n_skx" | "1n_tx2")
315             ssh="ssh root@172.17.0.1 -p 6022"
316             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
317             # The "declare -f" output is long and boring.
318             set +x
319             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
320                 die "Topology cleanup via shim-dcr failed!"
321             }
322             set -x
323             ;;
324         "1n_vbox")
325             enter_mutex || die
326             clean_environment || {
327                 die "Topology cleanup locally failed!"
328             }
329             exit_mutex || die
330             ;;
331         *)
332             die "Unknown specification: ${case_text}!"
333     esac
334 }
335
336
337 function die () {
338
339     # Print the message to standard error end exit with error code specified
340     # by the second argument.
341     #
342     # Hardcoded values:
343     # - The default error message.
344     # Arguments:
345     # - ${1} - The whole error message, be sure to quote. Optional
346     # - ${2} - the code to exit with, default: 1.
347
348     set -x
349     set +eu
350     warn "${1:-Unspecified run-time error occurred!}"
351     exit "${2:-1}"
352 }
353
354
355 function die_on_pybot_error () {
356
357     # Source this fragment if you want to abort on any failed test case.
358     #
359     # Variables read:
360     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
361     # Functions called:
362     # - die - Print to stderr and exit.
363
364     set -exuo pipefail
365
366     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
367         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
368     fi
369 }
370
371
372 function generate_tests () {
373
374     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
375     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
376     # The generation is done by executing any *.py executable
377     # within any subdirectory after copying.
378
379     # This is a separate function, because this code is called
380     # both by autogen checker and entries calling run_pybot.
381
382     # Directories read:
383     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
384     # Directories replaced:
385     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
386
387     set -exuo pipefail
388
389     rm -rf "${GENERATED_DIR}/tests" || die
390     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
391     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
392     cmd_line+=("-executable" "-name" "*.py")
393     # We sort the directories, so log output can be compared between runs.
394     file_list=$("${cmd_line[@]}" | sort) || die
395
396     for gen in ${file_list}; do
397         directory="$(dirname "${gen}")" || die
398         filename="$(basename "${gen}")" || die
399         pushd "${directory}" || die
400         ./"${filename}" || die
401         popd || die
402     done
403 }
404
405
406 function get_test_code () {
407
408     # Arguments:
409     # - ${1} - Optional, argument of entry script (or empty as unset).
410     #   Test code value to override job name from environment.
411     # Variables read:
412     # - JOB_NAME - String affecting test selection, default if not argument.
413     # Variables set:
414     # - TEST_CODE - The test selection string from environment or argument.
415     # - NODENESS - Node multiplicity of desired testbed.
416     # - FLAVOR - Node flavor string, usually describing the processor.
417
418     set -exuo pipefail
419
420     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
421     if [[ -z "${TEST_CODE}" ]]; then
422         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
423     fi
424
425     case "${TEST_CODE}" in
426         *"1n-vbox"*)
427             NODENESS="1n"
428             FLAVOR="vbox"
429             ;;
430         *"1n-skx"*)
431             NODENESS="1n"
432             FLAVOR="skx"
433             ;;
434        *"1n-tx2"*)
435             NODENESS="1n"
436             FLAVOR="tx2"
437             ;;
438         *"2n-skx"*)
439             NODENESS="2n"
440             FLAVOR="skx"
441             ;;
442         *"2n-zn2"*)
443             NODENESS="2n"
444             FLAVOR="zn2"
445             ;;
446         *"3n-skx"*)
447             NODENESS="3n"
448             FLAVOR="skx"
449             ;;
450         *"2n-clx"*)
451             NODENESS="2n"
452             FLAVOR="clx"
453             ;;
454         *"2n-dnv"*)
455             NODENESS="2n"
456             FLAVOR="dnv"
457             ;;
458         *"3n-dnv"*)
459             NODENESS="3n"
460             FLAVOR="dnv"
461             ;;
462         *"3n-tsh"*)
463             NODENESS="3n"
464             FLAVOR="tsh"
465             ;;
466         *)
467             # Fallback to 3-node Haswell by default (backward compatibility)
468             NODENESS="3n"
469             FLAVOR="hsw"
470             ;;
471     esac
472 }
473
474
475 function get_test_tag_string () {
476
477     # Variables read:
478     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
479     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
480     # - TEST_CODE - The test selection string from environment or argument.
481     # Variables set:
482     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
483     #   May be empty, or even not set on event types not adding comment.
484
485     # TODO: ci-management scripts no longer need to perform this.
486
487     set -exuo pipefail
488
489     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
490         case "${TEST_CODE}" in
491             *"device"*)
492                 trigger="devicetest"
493                 ;;
494             *"perf"*)
495                 trigger="perftest"
496                 ;;
497             *)
498                 die "Unknown specification: ${TEST_CODE}"
499         esac
500         # Ignore lines not containing the trigger word.
501         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
502         # The vpp-csit triggers trail stuff we are not interested in.
503         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
504         # (except relying on \s whitespace, \S non-whitespace and . both).
505         # The last string is concatenated, only the middle part is expanded.
506         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
507         # On parsing error, TEST_TAG_STRING probably stays empty.
508         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
509         if [[ -z "${TEST_TAG_STRING-}" ]]; then
510             # Probably we got a base64 encoded comment.
511             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
512             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
513             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
514         fi
515         if [[ -n "${TEST_TAG_STRING-}" ]]; then
516             test_tag_array=(${TEST_TAG_STRING})
517             if [[ "${test_tag_array[0]}" == "icl" ]]; then
518                 export GRAPH_NODE_VARIANT="icl"
519                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
520             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
521                 export GRAPH_NODE_VARIANT="skx"
522                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
523             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
524                 export GRAPH_NODE_VARIANT="hsw"
525                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
526             fi
527         fi
528     fi
529 }
530
531
532 function installed () {
533
534     # Check if the given utility is installed. Fail if not installed.
535     #
536     # Duplicate of common.sh function, as this file is also used standalone.
537     #
538     # Arguments:
539     # - ${1} - Utility to check.
540     # Returns:
541     # - 0 - If command is installed.
542     # - 1 - If command is not installed.
543
544     set -exuo pipefail
545
546     command -v "${1}"
547 }
548
549
550 function move_archives () {
551
552     # Move archive directory to top of workspace, if not already there.
553     #
554     # ARCHIVE_DIR is positioned relative to CSIT_DIR,
555     # but in some jobs CSIT_DIR is not same as WORKSPACE
556     # (e.g. under VPP_DIR). To simplify ci-management settings,
557     # we want to move the data to the top. We do not want simple copy,
558     # as ci-management is eager with recursive search.
559     #
560     # As some scripts may call this function multiple times,
561     # the actual implementation use copying and deletion,
562     # so the workspace gets "union" of contents (except overwrites on conflict).
563     # The consequence is empty ARCHIVE_DIR remaining after this call.
564     #
565     # As the source directory is emptied,
566     # the check for dirs being different is essential.
567     #
568     # Variables read:
569     # - WORKSPACE - Jenkins workspace, move only if the value is not empty.
570     #   Can be unset, then it speeds up manual testing.
571     # - ARCHIVE_DIR - Path to directory with content to be moved.
572     # Directories updated:
573     # - ${WORKSPACE}/archives/ - Created if does not exist.
574     #   Content of ${ARCHIVE_DIR}/ is moved.
575     # Functions called:
576     # - die - Print to stderr and exit.
577
578     set -exuo pipefail
579
580     if [[ -n "${WORKSPACE-}" ]]; then
581         target=$(readlink -f "${WORKSPACE}/archives")
582         if [[ "${target}" != "${ARCHIVE_DIR}" ]]; then
583             mkdir -p "${target}" || die "Archives dir create failed."
584             cp -rf "${ARCHIVE_DIR}"/* "${target}" || die "Copy failed."
585             rm -rf "${ARCHIVE_DIR}"/* || die "Delete failed."
586         fi
587     fi
588 }
589
590
591 function reserve_and_cleanup_testbed () {
592
593     # Reserve physical testbed, perform cleanup, register trap to unreserve.
594     # When cleanup fails, remove from topologies and keep retrying
595     # until all topologies are removed.
596     #
597     # Variables read:
598     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
599     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
600     # - BUILD_TAG - Any string suitable as filename, identifying
601     #   test run executing this function. May be unset.
602     # Variables set:
603     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
604     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
605     # Functions called:
606     # - die - Print to stderr and exit.
607     # - ansible_playbook - Perform an action using ansible, see ansible.sh
608     # Traps registered:
609     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
610
611     set -exuo pipefail
612
613     while true; do
614         for topo in "${TOPOLOGIES[@]}"; do
615             set +e
616             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
617             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
618             python3 "${scrpt}" "${opts[@]}"
619             result="$?"
620             set -e
621             if [[ "${result}" == "0" ]]; then
622                 # Trap unreservation before cleanup check,
623                 # so multiple jobs showing failed cleanup improve chances
624                 # of humans to notice and fix.
625                 WORKING_TOPOLOGY="${topo}"
626                 echo "Reserved: ${WORKING_TOPOLOGY}"
627                 trap "untrap_and_unreserve_testbed" EXIT || {
628                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
629                     untrap_and_unreserve_testbed "${message}" || {
630                         die "Teardown should have died, not failed."
631                     }
632                     die "Trap attempt failed, unreserve succeeded. Aborting."
633                 }
634                 # Cleanup + calibration checks.
635                 set +e
636                 ansible_playbook "cleanup, calibration"
637                 result="$?"
638                 set -e
639                 if [[ "${result}" == "0" ]]; then
640                     break
641                 fi
642                 warn "Testbed cleanup failed: ${topo}"
643                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
644             fi
645             # Else testbed is accessible but currently reserved, moving on.
646         done
647
648         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
649             # Exit the infinite while loop if we made a reservation.
650             warn "Reservation and cleanup successful."
651             break
652         fi
653
654         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
655             die "Run out of operational testbeds!"
656         fi
657
658         # Wait ~3minutes before next try.
659         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
660             die "Sleep time calculation failed."
661         }
662         echo "Sleeping ${sleep_time}"
663         sleep "${sleep_time}" || die "Sleep failed."
664     done
665 }
666
667
668 function run_pybot () {
669
670     # Run pybot with options based on input variables. Create output_info.xml
671     #
672     # Variables read:
673     # - CSIT_DIR - Path to existing root of local CSIT git repository.
674     # - ARCHIVE_DIR - Path to store robot result files in.
675     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
676     # - GENERATED_DIR - Tests are assumed to be generated under there.
677     # Variables set:
678     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
679     # Functions called:
680     # - die - Print to stderr and exit.
681
682     set -exuo pipefail
683
684     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
685     all_options+=("--noncritical" "EXPECTED_FAILING")
686     all_options+=("${EXPANDED_TAGS[@]}")
687
688     pushd "${CSIT_DIR}" || die "Change directory operation failed."
689     set +e
690     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
691     PYBOT_EXIT_STATUS="$?"
692     set -e
693
694     # Generate INFO level output_info.xml for post-processing.
695     all_options=("--loglevel" "INFO")
696     all_options+=("--log" "none")
697     all_options+=("--report" "none")
698     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
699     all_options+=("${ARCHIVE_DIR}/output.xml")
700     rebot "${all_options[@]}" || true
701     popd || die "Change directory operation failed."
702 }
703
704
705 function select_arch_os () {
706
707     # Set variables affected by local CPU architecture and operating system.
708     #
709     # Variables set:
710     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
711     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
712     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
713
714     set -exuo pipefail
715
716     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
717         die "Get OS release failed."
718     }
719
720     case "${os_id}" in
721         "ubuntu"*)
722             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
723             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
724             PKG_SUFFIX="deb"
725             ;;
726         "centos"*)
727             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
728             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
729             PKG_SUFFIX="rpm"
730             ;;
731         *)
732             die "Unable to identify distro or os from ${os_id}"
733             ;;
734     esac
735
736     arch=$(uname -m) || {
737         die "Get CPU architecture failed."
738     }
739
740     case "${arch}" in
741         "aarch64")
742             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
743             ;;
744         *)
745             ;;
746     esac
747 }
748
749
750 function select_tags () {
751
752     # Variables read:
753     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
754     # - TEST_CODE - String affecting test selection, usually jenkins job name.
755     # - DUT - CSIT test/ subdirectory, set while processing tags.
756     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
757     #   Can be unset.
758     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
759     # - BASH_FUNCTION_DIR - Directory with input files to process.
760     # Variables set:
761     # - TAGS - Array of processed tag boolean expressions.
762     # - SELECTION_MODE - Selection criteria [test, suite, include, exclude].
763
764     set -exuo pipefail
765
766     # NIC SELECTION
767     start_pattern='^  TG:'
768     end_pattern='^ \? \?[A-Za-z0-9]\+:'
769     # Remove the TG section from topology file
770     sed_command="/${start_pattern}/,/${end_pattern}/d"
771     # All topologies DUT NICs
772     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
773                 | grep -hoP "model: \K.*" | sort -u)
774     # Selected topology DUT NICs
775     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
776                | grep -hoP "model: \K.*" | sort -u)
777     # All topologies DUT NICs - Selected topology DUT NICs
778     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
779         die "Computation of excluded NICs failed."
780     }
781
782     # Select default NIC tag.
783     case "${TEST_CODE}" in
784         *"3n-dnv"* | *"2n-dnv"*)
785             default_nic="nic_intel-x553"
786             ;;
787         *"3n-tsh"*)
788             default_nic="nic_intel-x520-da2"
789             ;;
790         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
791             default_nic="nic_intel-xxv710"
792             ;;
793         *"3n-hsw"* | *"mrr-daily-master")
794             default_nic="nic_intel-xl710"
795             ;;
796         *)
797             default_nic="nic_intel-x710"
798             ;;
799     esac
800
801     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
802     awk_nics_sub_cmd=""
803     awk_nics_sub_cmd+='gsub("xxv710","25ge2p1xxv710");'
804     awk_nics_sub_cmd+='gsub("x710","10ge2p1x710");'
805     awk_nics_sub_cmd+='gsub("xl710","40ge2p1xl710");'
806     awk_nics_sub_cmd+='gsub("x520","10ge2p1x520");'
807     awk_nics_sub_cmd+='gsub("x553","10ge2p1x553");'
808     awk_nics_sub_cmd+='gsub("cx556a","10ge2p1cx556a");'
809     awk_nics_sub_cmd+='gsub("vic1227","10ge2p1vic1227");'
810     awk_nics_sub_cmd+='gsub("vic1385","10ge2p1vic1385");'
811     awk_nics_sub_cmd+='if ($9 =="drv_avf") drv="avf-";'
812     awk_nics_sub_cmd+='else if ($9 =="drv_rdma_core") drv ="rdma-";'
813     awk_nics_sub_cmd+='else drv="";'
814     awk_nics_sub_cmd+='print "*"$7"-" drv $11"-"$5"."$3"-"$1"-" drv $11"-"$5'
815
816     # Tag file directory shorthand.
817     tfd="${JOB_SPECS_DIR}"
818     case "${TEST_CODE}" in
819         # Select specific performance tests based on jenkins job type variable.
820         *"ndrpdr-weekly"* )
821             readarray -t test_tag_array <<< $(grep -v "#" \
822                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
823                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
824             SELECTION_MODE="--test"
825             ;;
826         *"mrr-daily"* )
827             readarray -t test_tag_array <<< $(grep -v "#" \
828                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
829                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
830             SELECTION_MODE="--test"
831             ;;
832         *"mrr-weekly"* )
833             readarray -t test_tag_array <<< $(grep -v "#" \
834                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
835                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
836             SELECTION_MODE="--test"
837             ;;
838         *"report-iterative"* )
839             test_sets=(${TEST_TAG_STRING//:/ })
840             # Run only one test set per run
841             report_file=${test_sets[0]}.md
842             readarray -t test_tag_array <<< $(grep -v "#" \
843                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
844                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
845             SELECTION_MODE="--test"
846             ;;
847         *"report-coverage"* )
848             test_sets=(${TEST_TAG_STRING//:/ })
849             # Run only one test set per run
850             report_file=${test_sets[0]}.md
851             readarray -t test_tag_array <<< $(grep -v "#" \
852                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
853                 awk {"$awk_nics_sub_cmd"} || echo "perftest") || die
854             SELECTION_MODE="--test"
855             ;;
856         * )
857             if [[ -z "${TEST_TAG_STRING-}" ]]; then
858                 # If nothing is specified, we will run pre-selected tests by
859                 # following tags.
860                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
861                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
862                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
863                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
864                                 "!dot1q" "!drv_avf")
865             else
866                 # If trigger contains tags, split them into array.
867                 test_tag_array=(${TEST_TAG_STRING//:/ })
868             fi
869             SELECTION_MODE="--include"
870             ;;
871     esac
872
873     # Blacklisting certain tags per topology.
874     #
875     # Reasons for blacklisting:
876     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
877     # TODO: Add missing reasons here (if general) or where used (if specific).
878     case "${TEST_CODE}" in
879         *"2n-skx"*)
880             test_tag_array+=("!ipsec")
881             ;;
882         *"3n-skx"*)
883             test_tag_array+=("!ipsechw")
884             # Not enough nic_intel-xxv710 to support double link tests.
885             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
886             ;;
887         *"2n-clx"*)
888             test_tag_array+=("!ipsec")
889             ;;
890         *"2n-zn2"*)
891             test_tag_array+=("!ipsec")
892             ;;
893         *"2n-dnv"*)
894             test_tag_array+=("!ipsechw")
895             test_tag_array+=("!memif")
896             test_tag_array+=("!srv6_proxy")
897             test_tag_array+=("!vhost")
898             test_tag_array+=("!vts")
899             test_tag_array+=("!drv_avf")
900             ;;
901         *"3n-dnv"*)
902             test_tag_array+=("!memif")
903             test_tag_array+=("!srv6_proxy")
904             test_tag_array+=("!vhost")
905             test_tag_array+=("!vts")
906             test_tag_array+=("!drv_avf")
907             ;;
908         *"3n-tsh"*)
909             # 3n-tsh only has x520 NICs which don't work with AVF
910             test_tag_array+=("!drv_avf")
911             test_tag_array+=("!ipsechw")
912             ;;
913         *"3n-hsw"*)
914             test_tag_array+=("!drv_avf")
915             # All cards have access to QAT. But only one card (xl710)
916             # resides in same NUMA as QAT. Other cards must go over QPI
917             # which we do not want to even run.
918             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
919             ;;
920         *)
921             # Default to 3n-hsw due to compatibility.
922             test_tag_array+=("!drv_avf")
923             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
924             ;;
925     esac
926
927     # We will add excluded NICs.
928     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
929
930     TAGS=()
931     prefix=""
932
933     set +x
934     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
935         # Automatic prefixing for VPP jobs to limit the NIC used and
936         # traffic evaluation to MRR.
937         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
938             prefix="${prefix}mrrAND"
939         else
940             prefix="${prefix}mrrAND${default_nic}AND"
941         fi
942     fi
943     for tag in "${test_tag_array[@]}"; do
944         if [[ "${tag}" == "!"* ]]; then
945             # Exclude tags are not prefixed.
946             TAGS+=("${tag}")
947         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
948             # Badly formed tag expressions can trigger way too much tests.
949             set -x
950             warn "The following tag expression hints at bad trigger: ${tag}"
951             warn "Possible cause: Multiple triggers in a single comment."
952             die "Aborting to avoid triggering too many tests."
953         elif [[ "${tag}" == *"OR"* ]]; then
954             # If OR had higher precedence than AND, it would be useful here.
955             # Some people think it does, thus triggering way too much tests.
956             set -x
957             warn "The following tag expression hints at bad trigger: ${tag}"
958             warn "Operator OR has lower precedence than AND. Use space instead."
959             die "Aborting to avoid triggering too many tests."
960         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
961             # Empty and comment lines are skipped.
962             # Other lines are normal tags, they are to be prefixed.
963             TAGS+=("${prefix}${tag}")
964         fi
965     done
966     set -x
967 }
968
969
970 function select_topology () {
971
972     # Variables read:
973     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
974     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
975     # - CSIT_DIR - Path to existing root of local CSIT git repository.
976     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
977     # Variables set:
978     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
979     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
980     # Functions called:
981     # - die - Print to stderr and exit.
982
983     set -exuo pipefail
984
985     case_text="${NODENESS}_${FLAVOR}"
986     case "${case_text}" in
987         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
988         # TODO: Double link availability depends on NIC used.
989         "1n_vbox")
990             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
991             TOPOLOGIES_TAGS="2_node_single_link_topo"
992             ;;
993         "1n_skx" | "1n_tx2")
994             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
995             TOPOLOGIES_TAGS="2_node_single_link_topo"
996             ;;
997         "2n_skx")
998             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
999             TOPOLOGIES_TAGS="2_node_*_link_topo"
1000             ;;
1001         "2n_zn2")
1002             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
1003             TOPOLOGIES_TAGS="2_node_*_link_topo"
1004             ;;
1005         "3n_skx")
1006             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
1007             TOPOLOGIES_TAGS="3_node_*_link_topo"
1008             ;;
1009         "2n_clx")
1010             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
1011             TOPOLOGIES_TAGS="2_node_*_link_topo"
1012             ;;
1013         "2n_dnv")
1014             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
1015             TOPOLOGIES_TAGS="2_node_single_link_topo"
1016             ;;
1017         "3n_dnv")
1018             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
1019             TOPOLOGIES_TAGS="3_node_single_link_topo"
1020             ;;
1021         "3n_hsw")
1022             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
1023             TOPOLOGIES_TAGS="3_node_single_link_topo"
1024             ;;
1025         "3n_tsh")
1026             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
1027             TOPOLOGIES_TAGS="3_node_single_link_topo"
1028             ;;
1029         *)
1030             # No falling back to 3n_hsw default, that should have been done
1031             # by the function which has set NODENESS and FLAVOR.
1032             die "Unknown specification: ${case_text}"
1033     esac
1034
1035     if [[ -z "${TOPOLOGIES-}" ]]; then
1036         die "No applicable topology found!"
1037     fi
1038 }
1039
1040
1041 function select_vpp_device_tags () {
1042
1043     # Variables read:
1044     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1045     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1046     #   Can be unset.
1047     # Variables set:
1048     # - TAGS - Array of processed tag boolean expressions.
1049
1050     set -exuo pipefail
1051
1052     case "${TEST_CODE}" in
1053         # Select specific device tests based on jenkins job type variable.
1054         * )
1055             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1056                 # If nothing is specified, we will run pre-selected tests by
1057                 # following tags. Items of array will be concatenated by OR
1058                 # in Robot Framework.
1059                 test_tag_array=()
1060             else
1061                 # If trigger contains tags, split them into array.
1062                 test_tag_array=(${TEST_TAG_STRING//:/ })
1063             fi
1064             ;;
1065     esac
1066
1067     # Blacklisting certain tags per topology.
1068     #
1069     # Reasons for blacklisting:
1070     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1071     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1072     case "${TEST_CODE}" in
1073         *"1n-vbox"*)
1074             test_tag_array+=("!avf")
1075             test_tag_array+=("!vhost")
1076             ;;
1077         *)
1078             ;;
1079     esac
1080
1081     TAGS=()
1082
1083     # We will prefix with devicetest to prevent running other tests
1084     # (e.g. Functional).
1085     prefix="devicetestAND"
1086     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1087         # Automatic prefixing for VPP jobs to limit testing.
1088         prefix="${prefix}"
1089     fi
1090     for tag in "${test_tag_array[@]}"; do
1091         if [[ ${tag} == "!"* ]]; then
1092             # Exclude tags are not prefixed.
1093             TAGS+=("${tag}")
1094         else
1095             TAGS+=("${prefix}${tag}")
1096         fi
1097     done
1098 }
1099
1100 function untrap_and_unreserve_testbed () {
1101
1102     # Use this as a trap function to ensure testbed does not remain reserved.
1103     # Perhaps call directly before script exit, to free testbed for other jobs.
1104     # This function is smart enough to avoid multiple unreservations (so safe).
1105     # Topo cleanup is executed (call it best practice), ignoring failures.
1106     #
1107     # Hardcoded values:
1108     # - default message to die with if testbed might remain reserved.
1109     # Arguments:
1110     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1111     # Variables read (by inner function):
1112     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1113     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1114     # Variables written:
1115     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1116     # Trap unregistered:
1117     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1118     # Functions called:
1119     # - die - Print to stderr and exit.
1120     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1121
1122     set -xo pipefail
1123     set +eu  # We do not want to exit early in a "teardown" function.
1124     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1125     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1126     if [[ -z "${wt-}" ]]; then
1127         set -eu
1128         warn "Testbed looks unreserved already. Trap removal failed before?"
1129     else
1130         ansible_playbook "cleanup" || true
1131         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1132             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1133         }
1134         WORKING_TOPOLOGY=""
1135         set -eu
1136     fi
1137 }
1138
1139
1140 function warn () {
1141
1142     # Print the message to standard error.
1143     #
1144     # Arguments:
1145     # - ${@} - The text of the message.
1146
1147     set -exuo pipefail
1148
1149     echo "$@" >&2
1150 }